Summary:    A library for easy implementation of a VNC server
Name:       libvncserver
Version:    0.9.13
Release:    3
License:    GPLv2+
URL:        http://libvnc.github.io/
Source0:    https://github.com/LibVNC/libvncserver/archive/LibVNCServer-%{version}.tar.gz
Patch10: 0001-libvncserver-Add-API-to-add-custom-I-O-entry-points.patch
Patch11: 0002-libvncserver-Add-channel-security-handlers.patch
Patch12: 0003-libvncserver-auth-don-t-keep-security-handlers-from-.patch
Patch13: 0004-zlib-Clear-buffer-pointers-on-cleanup-444.patch
Patch14: 0001-libvncserver-don-t-NULL-out-internal-of-the-default-.patch
Patch15: 0001-free-vncRec-memory-in-rfbClientCleanup.patch
Patch102: libvncserver-LibVNCServer-0.9.13-system-crypto-policy.patch

BuildRequires:  gcc-c++ cmake3 pkgconfig(gnutls) pkgconfig(sdl2) pkgconfig(libsystemd) pkgconfig(x11)
BuildRequires:  pkgconfig(xdamage) pkgconfig(xext) pkgconfig(xrandr) pkgconfig(xtst) pkgconfig(xinerama)
BuildRequires:  pkgconfig(xfixes) pkgconfig(openssl) pkgconfig(zlib) pkgconfig(libjpeg) pkgconfig(libpng)
BuildRequires:  gettext-devel libgcrypt-devel lzo-devel lzo-minilzo pkgconfig(libcrypto) pkgconfig(libssl)
BuildRequires:  xorg-x11-xauth zlib-devel
# the folowing deps is for --with-x11vnc
BuildRequires:  pkgconfig(avahi-client) pkgconfig(ice) pkgconfig(x11) pkgconfig(xdamage) pkgconfig(xext)
BuildRequires:  pkgconfig(xfixes) pkgconfig(xi) pkgconfig(xinerama) pkgconfig(xrandr) pkgconfig(xtst)

%description
libvncserver is a set of programs using the RFB (Remote Frame Buffer) protocol.
They are designed to "export" a frame buffer via net: you set up a server and can
connect to it via VNC viewers. If the server supports WebSockets (which LibVNCServer does),
you can also connect using an in-browser VNC viewer like noVNC.
It is already in wide use for administration, but it is not that easy to program a server yourself.

%package devel
Summary:    Development files for %{name}
Requires:   %{name}%{?_isa} = %{version}-%{release}
Requires:   coreutils
Requires:   zlib-devel

%description devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%prep
%autosetup -n %{name}-LibVNCServer-%{version} -p1

rm -fv common/lzodefs.h common/lzoconf.h commmon/minilzo.h common/minilzo.c

# fix encoding
for file in ChangeLog ; do
    mv ${file} ${file}.OLD && \
    iconv -f ISO_8859-1 -t UTF8 ${file}.OLD > ${file} && \
    touch --reference ${file}.OLD $file
done

%build
%cmake3
%make_build

%install
%make_install

%ldconfig_scriptlets

%files
%license COPYING
%doc AUTHORS ChangeLog NEWS* README* TODO*
%{_libdir}/libvncclient.so.1
%{_libdir}/libvncclient.so.%{version}
%{_libdir}/libvncserver.so.1
%{_libdir}/libvncserver.so.%{version}

%files devel
%{_includedir}/rfb/
%{_libdir}/libvncclient.so
%{_libdir}/libvncserver.so
%{_libdir}/pkgconfig/libvncclient.pc
%{_libdir}/pkgconfig/libvncserver.pc

%changelog
* Wed Sep 28 2022 lin zhang <lin.zhang@turbolinux.com.cn> - 0.9.13-3
- fix-CVE-2020-29260
- add 0001-free-vncRec-memory-in-rfbClientCleanup.patch 

* Mon Jun 20 2022 lin zhang <lin.zhang@turbolinux.com.cn> - 0.9.13-2
- add libvncserver.yaml

* Wed Jun 30 2021 weijin deng <weijin.deng@turbolinux.com.cn> - 0.9.13-1
- Package init with 0.9.13
